Index: /profile/src/main/java/geniusweb/profile/utilityspace/SumOfGroupsUtilitySpace.java
===================================================================
--- /profile/src/main/java/geniusweb/profile/utilityspace/SumOfGroupsUtilitySpace.java	(revision 9)
+++ /profile/src/main/java/geniusweb/profile/utilityspace/SumOfGroupsUtilitySpace.java	(revision 9)
@@ -0,0 +1,279 @@
+package geniusweb.profile.utilityspace;
+
+import java.math.BigDecimal;
+import java.util.Arrays;
+import java.util.HashMap;
+import java.util.HashSet;
+import java.util.LinkedList;
+import java.util.List;
+import java.util.Map;
+import java.util.Set;
+
+import com.fasterxml.jackson.annotation.JsonAutoDetect;
+import com.fasterxml.jackson.annotation.JsonAutoDetect.Visibility;
+import com.fasterxml.jackson.annotation.JsonCreator;
+import com.fasterxml.jackson.annotation.JsonProperty;
+
+import geniusweb.issuevalue.Bid;
+import geniusweb.issuevalue.Domain;
+import geniusweb.issuevalue.NumberValueSet;
+import geniusweb.issuevalue.Value;
+import geniusweb.profile.DefaultProfile;
+
+/**
+ * This is a utility space that defines the utility of bids as a sum of the
+ * utilities of a number of subsets, or groups, of the issue values.
+ * <p>
+ * A group defines the utility of a non-empty subset of the issues in the
+ * domain. The parts are non-overlapping. Missing issue values have utility 0.
+ * <p>
+ * This space enables handling {@link UtilitySpace}s that are not simply linear
+ * additive, but with interacting issue values. For example, if you would like
+ * to have a car with good speakers but only if there is also a good hifi set,
+ * you can make a part that has {@link PartsUtilities} like
+ * <code> { { speakers:yes, hifi:yes }:1, {speakers, no: hifh:yes}:0.2, ...} </code>
+ * <p>
+ * NOTICE this space is completely discrete. There is no equivalent of the
+ * {@link NumberValueSet} here.
+ */
+@JsonAutoDetect(fieldVisibility = Visibility.ANY, getterVisibility = Visibility.NONE, setterVisibility = Visibility.NONE, isGetterVisibility = Visibility.NONE)
+public class SumOfGroupsUtilitySpace extends DefaultProfile
+		implements UtilitySpace {
+	/**
+	 * the key is the part name, the value is the valuesetutilities for this
+	 * issue. Should be immutable so do not return direct access to this field.
+	 */
+	private final HashMap<String, PartsUtilities> partUtilities = new HashMap<>();
+
+	/**
+	 * @param domain  the {@link Domain} in which this profile is defined.
+	 * @param name    the name of this profile. Must be simple name (a-Z, 0-9)
+	 * @param utils   a map with key: part names (String) and value: the
+	 *                {@link PartsUtilities} for that part. There MUST NOT be a
+	 *                null part name. All values MUST NOT be null. The
+	 *                PartsUtilities must match the
+	 * @param weights the weight of each part, for the computation of the
+	 *                weighted sum. The parts must be the same as those in the
+	 *                utils map. All weights MUST NOT be null. The weights MUST
+	 *                sum to 1.
+	 * @param resBid  the reservation bid. Only bids that are
+	 *                {@link #isPreferredOrEqual(Bid, Bid)} should be accepted.
+	 *                Can be null, meaning that there is no reservation bid and
+	 *                any agreement is better than no agreement.
+	 * @throws NullPointerException     if values are incorrectly null.
+	 * @throws IllegalArgumentException if preconditions not met.
+	 */
+	@JsonCreator
+	public SumOfGroupsUtilitySpace(@JsonProperty("domain") Domain domain,
+			@JsonProperty("name") String name,
+			@JsonProperty("partUtilities") HashMap<String, PartsUtilities> partutils,
+			// @JsonProperty("partWeights") Map<String, BigDecimal> weights,
+			@JsonProperty("reservationBid") Bid resBid) {
+		super(name, domain, resBid);
+		this.partUtilities.putAll(partutils);
+
+		String err = checkParts();
+		if (err != null) {
+			throw new IllegalArgumentException(err);
+		}
+	}
+
+	/**
+	 * Copy settings in las. This will have the exact same utilities as the las
+	 * but this then gives you the power to change it into a non-linear space by
+	 * grouping.
+	 * 
+	 * @param las the {@link LinearAdditiveUtilitySpace} to be converted/copied.
+	 * 
+	 */
+	public SumOfGroupsUtilitySpace(LinearAdditiveUtilitySpace las) {
+		this(las.getDomain(), las.getName(), las2parts(las),
+				las.getReservationBid());
+	}
+
+	@Override
+	public BigDecimal getUtility(Bid bid) {
+		return partUtilities.keySet().stream()
+				.map(partname -> util(partname, bid))
+				.reduce(BigDecimal.ZERO, BigDecimal::add);
+	}
+
+	@Override
+	public String toString() {
+		return "PartialAdditive[" + partUtilities + "," + getReservationBid()
+				+ "]";
+	}
+
+	/**
+	 * 
+	 * @param partnames   the partnames to remove from this. There must be at
+	 *                    least 2 parts
+	 * @param newpartname the name of the new part that contains all partnames,
+	 *                    grouped into 1 "issue". This name must not be an issue
+	 *                    in this.
+	 * @return new {@link SumOfGroupsUtilitySpace} that takes all partnames out
+	 *         of this, and makes a newaprtname that contains these.
+	 */
+	public SumOfGroupsUtilitySpace group(List<String> partnames,
+			String newpartname) {
+		final Set<String> allpartnames = partUtilities.keySet();
+
+		if (partnames.size() < 2) {
+			throw new IllegalArgumentException(
+					"Group must contain at least 2 parts");
+		}
+		if (allpartnames.contains(newpartname)) {
+			throw new IllegalArgumentException(
+					"newpartname " + newpartname + " is already in use");
+		}
+		for (String name : partnames) {
+			if (!allpartnames.contains(name)) {
+				throw new IllegalArgumentException("Unknown part name " + name);
+			}
+		}
+
+		HashMap<String, PartsUtilities> newutils = new HashMap<String, PartsUtilities>();
+
+		PartsUtilities newpartutils = null;
+
+		for (String name : partUtilities.keySet()) {
+			if (partnames.contains(name)) {
+				if (newpartutils == null) {
+					newpartutils = partUtilities.get(name);
+				} else {
+					newpartutils = newpartutils.add(partUtilities.get(name));
+				}
+			} else {
+				newutils.put(name, partUtilities.get(name));
+			}
+		}
+		newutils.put(newpartname, newpartutils);
+
+		return new SumOfGroupsUtilitySpace(getDomain(), getName(), newutils,
+				getReservationBid());
+	}
+
+	@Override
+	public int hashCode() {
+		final int prime = 31;
+		int result = super.hashCode();
+		result = prime * result
+				+ ((partUtilities == null) ? 0 : partUtilities.hashCode());
+		return result;
+	}
+
+	@Override
+	public boolean equals(Object obj) {
+		if (this == obj)
+			return true;
+		if (!super.equals(obj))
+			return false;
+		if (getClass() != obj.getClass())
+			return false;
+		SumOfGroupsUtilitySpace other = (SumOfGroupsUtilitySpace) obj;
+		if (partUtilities == null) {
+			if (other.partUtilities != null)
+				return false;
+		} else if (!partUtilities.equals(other.partUtilities))
+			return false;
+		return true;
+	}
+
+	/***************************** private funcs ***************************/
+	/**
+	 * 
+	 * @param partname the name of the part to get the utility of
+	 * @param bid      the bid
+	 * @return weighted util of just the part: utilities[part].getUtility(part
+	 *         of bid)
+	 */
+	private BigDecimal util(String partname, Bid bid) {
+		PartsUtilities partutils = partUtilities.get(partname);
+		ProductOfValue value = collectValues(bid, partutils);
+		return partutils.getUtility(value);
+	}
+
+	/**
+	 * 
+	 * @param bid       a full bid
+	 * @param partutils the part utils for which a list of values from the bid
+	 *                  is needed
+	 * @return a list of values from the given bid, ordered as indicated in
+	 *         partutils
+	 */
+	private ProductOfValue collectValues(Bid bid, PartsUtilities partutils) {
+		List<Value> values = new LinkedList<>();
+		for (String issue : partutils.getIssues()) {
+			values.add(bid.getValue(issue));
+		}
+		return new ProductOfValue(values);
+	}
+
+	/**
+	 * 
+	 * @param las a {@link LinearAdditiveUtilitySpace}
+	 * @return a Map with partname-PartsUtilities. The partnames are identical
+	 *         to the issues in the given las.
+	 */
+	private static HashMap<String, PartsUtilities> las2parts(
+			LinearAdditiveUtilitySpace las) {
+
+		HashMap<String, PartsUtilities> map = new HashMap<>();
+		for (String issue : las.getUtilities().keySet()) {
+			ValueSetUtilities valset = las.getUtilities().get(issue);
+			Map<ProductOfValue, BigDecimal> utilslist = new HashMap<>();
+			BigDecimal weight = las.getWeight(issue);
+			for (Value val : las.getDomain().getValues(issue)) {
+				BigDecimal util = valset.getUtility(val).multiply(weight);
+				if (BigDecimal.ZERO.compareTo(util) != 0) {
+					utilslist.put(new ProductOfValue(Arrays.asList(val)), util);
+				}
+			}
+			map.put(issue, new PartsUtilities(Arrays.asList(issue), utilslist));
+		}
+		return map;
+	}
+
+	/**
+	 * 
+	 * @return error string, or null if no error (all parts seem fine)
+	 */
+	private String checkParts() {
+
+		Set<String> collectedIssues = new HashSet<>();
+		for (String partname : partUtilities.keySet()) {
+			PartsUtilities part = partUtilities.get(partname);
+			if (part == null) {
+				return "partUtilities " + partname + " contains null value";
+			}
+			List<String> issues = part.getIssues();
+			HashSet<String> intersection = new HashSet<String>(collectedIssues);
+			intersection.retainAll(issues);
+			if (!intersection.isEmpty()) {
+				return "issues " + intersection + " occur multiple times";
+			}
+			collectedIssues.addAll(issues);
+		}
+
+		if (!collectedIssues.equals(getDomain().getIssues())) {
+			return "parts must cover the domain issues "
+					+ getDomain().getIssues() + " but cover " + collectedIssues;
+		}
+		if (getMaxUtility().compareTo(BigDecimal.ONE) > 0) {
+			return "Max utility of the space exceedds 1";
+		}
+		return null;
+
+	}
+
+	/**
+	 * 
+	 * @return the max possible utility in this utility space.
+	 */
+	private BigDecimal getMaxUtility() {
+		return partUtilities.values().stream()
+				.map(partutils -> partutils.getMaxUtility())
+				.reduce(BigDecimal.ZERO, BigDecimal::add);
+	}
+
+}
Index: /profile/src/test/java/geniusweb/profile/utilityspace/DiscreteValueSetUtilitiesTest.java
===================================================================
--- /profile/src/test/java/geniusweb/profile/utilityspace/DiscreteValueSetUtilitiesTest.java	(revision 8)
+++ /profile/src/test/java/geniusweb/profile/utilityspace/DiscreteValueSetUtilitiesTest.java	(revision 9)
@@ -3,4 +3,5 @@
 import static org.junit.Assert.assertEquals;
 import static org.junit.Assert.assertFalse;
+import static org.junit.Assert.assertTrue;
 
 import java.io.IOException;
@@ -81,8 +82,8 @@
 	@Override
 	public List<String> getGeneralTestStrings() {
-		return Arrays.asList("ValueSetUtilities\\{\"a\"=0.14\\}",
-				"ValueSetUtilities\\{\"b\"=0.37\\}",
-				"ValueSetUtilities\\{\"a\"=0.37\\}",
-				"ValueSetUtilities\\{\"a\"=0.14, \"b\"=0.37\\}");
+		return Arrays.asList("DiscreteValueSetUtilities\\{\"a\"=0.14\\}",
+				"DiscreteValueSetUtilities\\{\"b\"=0.37\\}",
+				"DiscreteValueSetUtilities\\{\"a\"=0.37\\}",
+				"DiscreteValueSetUtilities\\{\"a\"=0.14, \"b\"=0.37\\}");
 	}
 
@@ -200,3 +201,17 @@
 
 	}
+
+	@Test
+	public void testDeserializeAsDiscrete()
+			throws JsonParseException, JsonMappingException, IOException {
+		// Check that DiscreteValueSetUtilities properly deserializes
+		// discreteutils.
+		String utilstring = "{\"discreteutils\": {\"valueUtilities\": {\"Party Tent\": 0.52,\"Your Dorm\": 0.23,\"Party Room\": 0.99,\"Ballroom\": 0.77}}}";
+		DiscreteValueSetUtilities valueutils = jackson.readValue(utilstring,
+				DiscreteValueSetUtilities.class);
+		assertTrue(new BigDecimal("0.23").compareTo(
+				valueutils.getUtility(new DiscreteValue("Your Dorm"))) == 0);
+
+	}
+
 }
Index: /profile/src/test/java/geniusweb/profile/utilityspace/LinearAdditiveTest.java
===================================================================
--- /profile/src/test/java/geniusweb/profile/utilityspace/LinearAdditiveTest.java	(revision 8)
+++ /profile/src/test/java/geniusweb/profile/utilityspace/LinearAdditiveTest.java	(revision 9)
@@ -20,5 +20,4 @@
 
 import com.fasterxml.jackson.databind.ObjectMapper;
-import com.fasterxml.jackson.databind.exc.InvalidDefinitionException;
 
 import geniusweb.issuevalue.Bid;
@@ -145,8 +144,8 @@
 	public List<String> getGeneralTestStrings() {
 		return Arrays.asList(
-				"LinearAdditive\\[\\{issue2=ValueSetUtilities\\{\"issue2value2\"=0.8, \"issue2value1\"=0.6\\}, issue1=ValueSetUtilities\\{\"issue1value1\"=0.3, \"issue1value2\"=0.2\\}\\},\\{issue2=0.6, issue1=0.4\\},Bid\\{issue2=\"issue2value1\", issue1=\"issue1value2\"\\}\\]",
-				"LinearAdditive\\[\\{issue2=ValueSetUtilities\\{\"issue2value2\"=0.8, \"issue2value1\"=0.6\\}, issue1=ValueSetUtilities\\{\"issue1value1\"=0.3, \"issue1value2\"=0.2\\}\\},\\{issue2=0.7, issue1=0.3\\},Bid\\{issue2=\"issue2value1\", issue1=\"issue1value2\"\\}\\]",
-				"LinearAdditive\\[\\{issue2=ValueSetUtilities\\{\"issue2value2\"=0.2, \"issue2value1\"=0.3\\}, issue1=ValueSetUtilities\\{\"issue1value1\"=0.6, \"issue1value2\"=0.8\\}\\},\\{issue2=0.6, issue1=0.4\\},Bid\\{issue2=\"issue2value1\", issue1=\"issue1value2\"\\}\\]",
-				"LinearAdditive\\[\\{issue2=ValueSetUtilities\\{\"issue2value2\"=0.2, \"issue2value1\"=0.3\\}, issue1=ValueSetUtilities\\{\"issue1value1\"=0.6, \"issue1value2\"=0.8\\}\\},\\{issue2=0.6, issue1=0.4\\},Bid\\{issue2=\"issue2value1\", issue1=\"issue1value1\"\\}\\]");
+				"LinearAdditive\\[\\{issue2=DiscreteValueSetUtilities\\{\"issue2value2\"=0.8, \"issue2value1\"=0.6\\}, issue1=DiscreteValueSetUtilities\\{\"issue1value1\"=0.3, \"issue1value2\"=0.2\\}\\},\\{issue2=0.6, issue1=0.4\\},Bid\\{issue2=\"issue2value1\", issue1=\"issue1value2\"\\}\\]",
+				"LinearAdditive\\[\\{issue2=DiscreteValueSetUtilities\\{\"issue2value2\"=0.8, \"issue2value1\"=0.6\\}, issue1=DiscreteValueSetUtilities\\{\"issue1value1\"=0.3, \"issue1value2\"=0.2\\}\\},\\{issue2=0.7, issue1=0.3\\},Bid\\{issue2=\"issue2value1\", issue1=\"issue1value2\"\\}\\]",
+				"LinearAdditive\\[\\{issue2=DiscreteValueSetUtilities\\{\"issue2value2\"=0.2, \"issue2value1\"=0.3\\}, issue1=DiscreteValueSetUtilities\\{\"issue1value1\"=0.6, \"issue1value2\"=0.8\\}\\},\\{issue2=0.6, issue1=0.4\\},Bid\\{issue2=\"issue2value1\", issue1=\"issue1value2\"\\}\\]",
+				"LinearAdditive\\[\\{issue2=DiscreteValueSetUtilities\\{\"issue2value2\"=0.2, \"issue2value1\"=0.3\\}, issue1=DiscreteValueSetUtilities\\{\"issue1value1\"=0.6, \"issue1value2\"=0.8\\}\\},\\{issue2=0.6, issue1=0.4\\},Bid\\{issue2=\"issue2value1\", issue1=\"issue1value1\"\\}\\]");
 	}
 
@@ -271,5 +270,5 @@
 	}
 
-	@Test(expected = InvalidDefinitionException.class)
+	@Test
 	public void loadFullWithJson() throws IOException {
 		String profile = new String(
Index: /profile/src/test/java/geniusweb/profile/utilityspace/NumberValueSetUtilTest.java
===================================================================
--- /profile/src/test/java/geniusweb/profile/utilityspace/NumberValueSetUtilTest.java	(revision 8)
+++ /profile/src/test/java/geniusweb/profile/utilityspace/NumberValueSetUtilTest.java	(revision 9)
@@ -44,7 +44,7 @@
 	@Override
 	public List<String> getGeneralTestStrings() {
-		return Arrays.asList("NumberValUtility\\(12.5->0.5,18.5->0.9\\)",
-				"NumberValUtility\\(12.5->0.6,18.5->0.9\\)",
-				"NumberValUtility\\(12.5->0.5,18.4->0.9\\)");
+		return Arrays.asList("NumberValueSetUtilities\\(12.5->0.5,18.5->0.9\\)",
+				"NumberValueSetUtilities\\(12.5->0.6,18.5->0.9\\)",
+				"NumberValueSetUtilities\\(12.5->0.5,18.4->0.9\\)");
 	}
 
Index: /profile/src/test/java/geniusweb/profile/utilityspace/PartsUtilitiesTest.java
===================================================================
--- /profile/src/test/java/geniusweb/profile/utilityspace/PartsUtilitiesTest.java	(revision 9)
+++ /profile/src/test/java/geniusweb/profile/utilityspace/PartsUtilitiesTest.java	(revision 9)
@@ -0,0 +1,144 @@
+package geniusweb.profile.utilityspace;
+
+import static org.junit.Assert.assertEquals;
+import static org.junit.Assert.assertTrue;
+
+import java.io.IOException;
+import java.math.BigDecimal;
+import java.util.Arrays;
+import java.util.HashMap;
+import java.util.LinkedList;
+import java.util.List;
+import java.util.Map;
+
+import org.junit.Before;
+import org.junit.Test;
+
+import com.fasterxml.jackson.core.JsonParseException;
+import com.fasterxml.jackson.databind.JsonMappingException;
+import com.fasterxml.jackson.databind.ObjectMapper;
+
+import geniusweb.issuevalue.DiscreteValue;
+import geniusweb.issuevalue.Value;
+import tudelft.utilities.junit.GeneralTests;
+
+public class PartsUtilitiesTest extends GeneralTests<PartsUtilities> {
+	private static final String iss2 = "issue2";
+
+	private static final String iss1 = "issue1";
+
+	private final ObjectMapper jackson = new ObjectMapper();
+
+	private static BigDecimal N01 = new BigDecimal("0.1"),
+			N02 = new BigDecimal("0.2"), N03 = new BigDecimal("0.3"),
+			N05 = new BigDecimal("0.5"), N07 = new BigDecimal("0.7"),
+			N08 = new BigDecimal("0.8"), N09 = new BigDecimal("0.9");
+	private final static DiscreteValue low = new DiscreteValue("low");
+	private final static DiscreteValue high = new DiscreteValue("high");
+
+	private final static String jsontext = "{\"partsutils\":{\"issues\":[\"issue1\",\"issue2\"],\"utilslist\":[{\"values\":[\"low\",\"low\"],\"util\":0.3},{\"values\":[\"high\",\"high\"],\"util\":0.9}]}}";
+
+	private PartsUtilities parts1, parts1a, parts2, parts3;
+
+	@Before
+	public void before() {
+		List<PartUtil> vals = new LinkedList<>();
+		vals.add(new PartUtil(Arrays.asList(low, low), N03));
+		vals.add(new PartUtil(Arrays.asList(high, high), N09));
+		List<PartUtil> vals1 = new LinkedList<>();
+		vals1.add(new PartUtil(Arrays.asList(low, low), N09));
+		List<String> issues = Arrays.asList(iss1, iss2);
+		parts1 = new PartsUtilities(issues, vals);
+		parts1a = new PartsUtilities(issues, vals);
+		parts2 = new PartsUtilities(Arrays.asList(iss1), vals);
+		parts3 = new PartsUtilities(issues, vals1);
+	}
+
+	@Override
+	public List<List<PartsUtilities>> getGeneralTestData() {
+		return Arrays.asList(Arrays.asList(parts1, parts1a),
+				Arrays.asList(parts2), Arrays.asList(parts3));
+	}
+
+	@Override
+	public List<String> getGeneralTestStrings() {
+		return Arrays.asList(
+				"PartsUtilities..issue1, issue2.,\\{.\"low\", \"low\".=0.3, .\"high\", \"high\".=0.9\\}.",
+				"PartsUtilities..issue1.,\\{.\"low\", \"low\".=0.3, .\"high\", \"high\".=0.9\\}.",
+				"PartsUtilities..issue1, issue2.,\\{.\"low\", \"low\".=0.9\\}.");
+	}
+
+	@Test(expected = IllegalArgumentException.class)
+	public void testWeightsTooHigh() {
+		Map<ProductOfValue, BigDecimal> utils = new HashMap<>();
+		utils.put(new ProductOfValue(Arrays.asList(low, low)),
+				new BigDecimal("1.1"));
+		new PartsUtilities(Arrays.asList(iss1, iss2), utils);
+	}
+
+	@Test(expected = IllegalArgumentException.class)
+	public void testWeightsTooLow() {
+		Map<ProductOfValue, BigDecimal> utils = new HashMap<>();
+		utils.put(new ProductOfValue(Arrays.asList(low, low)),
+				new BigDecimal("-0.3"));
+		new PartsUtilities(Arrays.asList(iss1, iss2), utils);
+	}
+
+	@Test
+	public void testBasicSerialize()
+			throws JsonParseException, JsonMappingException, IOException {
+		System.out.println(jsontext);
+		assertEquals(jsontext, jackson.writeValueAsString(parts1));
+	}
+
+	@Test
+	public void testBasicDeserialize()
+			throws JsonParseException, JsonMappingException, IOException {
+		System.out.println(jsontext);
+		assertEquals(parts1, jackson.readValue(jsontext, PartsUtilities.class));
+	}
+
+	@Test
+	public void testGetUtility() {
+		assertEquals(N03,
+				parts1.getUtility(new ProductOfValue(Arrays.asList(low, low))));
+		assertEquals(N09, parts1
+				.getUtility(new ProductOfValue(Arrays.asList(high, high))));
+		assertEquals(BigDecimal.ZERO, parts1
+				.getUtility(new ProductOfValue(Arrays.asList(low, high))));
+	}
+
+	@Test
+	public void testGetIssues() {
+		assertEquals(Arrays.asList(iss1, iss2), parts1.getIssues());
+	}
+
+	@Test
+	public void testGetIncorrectValue() {
+		assertEquals(BigDecimal.ZERO, parts1.getUtility(low));
+	}
+
+	@Test
+	public void testGetValue() {
+		assertTrue(N03.compareTo(parts1
+				.getUtility(new ProductOfValue(Arrays.asList(low, low)))) == 0);
+	}
+
+	@Test
+	public void testMerge() {
+		Map<ProductOfValue, BigDecimal> extravals = new HashMap<>();
+		extravals.put(new ProductOfValue(Arrays.asList(low, low)),
+				N01.multiply(N05));
+		extravals.put(new ProductOfValue(Arrays.asList(high, high)),
+				N01.multiply(N07));
+		PartsUtilities extraparts = new PartsUtilities(
+				Arrays.asList("extra1", "extra2"), extravals);
+
+		PartsUtilities merged = parts1.add(extraparts);
+
+		Value pval = new ProductOfValue(Arrays.asList(low, low, high, high));
+		assertEquals(0,
+				N03.add(N01.multiply(N07)).compareTo(merged.getUtility(pval)));
+	}
+
+}
Index: /profile/src/test/java/geniusweb/profile/utilityspace/ProductOfValueTest.java
===================================================================
--- /profile/src/test/java/geniusweb/profile/utilityspace/ProductOfValueTest.java	(revision 9)
+++ /profile/src/test/java/geniusweb/profile/utilityspace/ProductOfValueTest.java	(revision 9)
@@ -0,0 +1,78 @@
+package geniusweb.profile.utilityspace;
+
+import static org.junit.Assert.assertEquals;
+import static org.mockito.Mockito.mock;
+
+import java.io.IOException;
+import java.util.Arrays;
+import java.util.List;
+
+import org.junit.Test;
+
+import com.fasterxml.jackson.core.JsonParseException;
+import com.fasterxml.jackson.databind.JsonMappingException;
+import com.fasterxml.jackson.databind.ObjectMapper;
+
+import geniusweb.issuevalue.DiscreteValue;
+import geniusweb.issuevalue.Value;
+import tudelft.utilities.junit.GeneralTests;
+
+public class ProductOfValueTest extends GeneralTests<ProductOfValue> {
+	private final static ObjectMapper jackson = new ObjectMapper();
+
+	private final static Value value1 = new DiscreteValue("val1");
+	private final static Value value2 = new DiscreteValue("val2");
+	private final static ProductOfValue values1 = new ProductOfValue(
+			Arrays.asList(value1, value2));
+	private final static ProductOfValue values1a = new ProductOfValue(
+			Arrays.asList(value1, value2));
+	private final static ProductOfValue values2 = new ProductOfValue(
+			Arrays.asList(value2));
+	private final static DiscreteValue low = new DiscreteValue("low");
+	private final static DiscreteValue high = new DiscreteValue("high");
+
+	private String jsontext = "[\"val1\",\"val2\"]";
+
+	@Override
+	public List<List<ProductOfValue>> getGeneralTestData() {
+		return Arrays.asList(Arrays.asList(values1, values1a),
+				Arrays.asList(values2));
+	}
+
+	@Override
+	public List<String> getGeneralTestStrings() {
+		return Arrays.asList(".*\"val1\", \"val2\".*", ".*\"val2\".*");
+	}
+
+	@Test
+	public void testSerialize()
+			throws JsonParseException, JsonMappingException, IOException {
+
+		assertEquals(jsontext, jackson.writeValueAsString(values1));
+	}
+
+	@Test
+	public void testBasicDeserialize()
+			throws JsonParseException, JsonMappingException, IOException {
+		System.out.println(jsontext);
+		assertEquals(values1,
+				jackson.readValue(jsontext, ProductOfValue.class));
+	}
+
+	@Test
+	public void testMerge() {
+		Value val1 = mock(Value.class);
+		Value val2 = mock(Value.class);
+		Value val3 = mock(Value.class);
+		Value val4 = mock(Value.class);
+
+		ProductOfValue prodOfVal1 = new ProductOfValue(
+				Arrays.asList(val1, val2));
+		ProductOfValue prodOfVal2 = new ProductOfValue(
+				Arrays.asList(val3, val4));
+
+		ProductOfValue prodVal = prodOfVal1.merge(prodOfVal2);
+		assertEquals(4, prodVal.getValues().size());
+	}
+
+}
